#ifndef __GACORE_H__
#define __GACORE_H__

#include "GAunit.h"

// version
#define GASIM_VERSION "1.17"

class CGAcore
{
public:
	// GAp[^
	CGAparam		*m_param;
	// 쐧
	int				m_proc_loop_main;      // (o) GAs
	int				m_proc_loop_gene;      // (o) GA㐔
	int				m_proc_score;          // (o) Kx
	int				m_proc_time;           // (o) Z[ms]
	int				m_proc_stat[NUM_STAT]; // (o) ݂̃Xe[^X
	int				m_proc_smin[NUM_STAT]; // (i) Xe[^XڕWl(UIύX)
	int				m_proc_smax[NUM_STAT]; // (i) Xe[^Xől(UIύX)
	bool			m_proc_isdone;         // (o) GAV~[VItrueɃZbg
	bool			m_proc_modify;         // (i) UIŃXe[^XύXꂽtrueɃZbg邱
	bool			m_proc_cancel;         // (i) UIŃLZꂽtrueɃZbg邱

	// ϐ̊S
	// V~[V̍ŏɎs邱
	void			initialize();
	void			initialize(CGAparam &gaparam);
	// p[^`FbN
	// p[^ݒɎs邱
	bool			validate(char *errmsg);

	void			genetic_entrypoint(CGAunit &unit_in, CGAunit &unit_out, bool use_unit_in);
	void			genetic_main(CGAunit *unit_list);
	void			genetic_init_list(int &unit_num, CGAunit *unit_list, CGAunit &unit_in, bool use_unit_in);
	bool			genetic_add_unique(int &unit_num, CGAunit *unit_list, CGAunit &unit_new);
	void			genetic_sort(CGAunit &src, CGAunit &dst);
	void			rand_init();
	int				rand_rank();

	template <typename T> void swap(T &val1, T &val2)
		{ T tmp = val1; val1 = val2; val2 = tmp; };
};

#endif // __GACORE_H__
