#ifndef __GAIMEX_H__
#define __GAIMEX_H__

#include "GAunit.h"

class GAimex
{
public:
	CGAparam		*m_param;
	CGAunit			*m_unit;

	// 
	virtual void	init(CGAparam &param, CGAunit &unit);

	// `qAƃȎݕϊ
	// ͊eV~[^̔hNXōs
	virtual void	imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log) = 0;
	virtual void	imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log) = 0;

	// Oo͖{
	virtual void	import_log(CGAparam &param, CGAunit &unit, char *log);
	virtual void	export_log(CGAparam &param, CGAunit &unit, char *log);

	// Tu֐
	void			_strcat(char *log, char *format, ...);
	bool			_sgets(char *&pos, char *buf);
	void			_fix_stat();

	// Tu֐()
	inline int		conv_elem2idx_xien(ETYPE elem) { return (elem & ELEM_MASK_XIEN) >> ELEM_STARTBIT_XIEN; };
	inline int		conv_elem2idx_stat(ETYPE elem) { return (elem & ELEM_MASK_STAT) >> ELEM_STARTBIT_STAT; };
	inline int		conv_str2idx_xien(char *str)   { return m_param->str2idx(str); };
	inline int		conv_str2idx_stat(char *str)   { return m_param->str2idx(str); };
	inline char *	conv_idx2str_xien(int index)   { return m_param->xien_name(index); };
	inline char *	conv_idx2str_stat(int index)   { return m_param->stat_name(index); };
	inline char *	conv_elem2str_xien(ETYPE elem) { return conv_idx2str_xien(conv_elem2idx_xien(elem)); };
	inline char *	conv_elem2str_stat(ETYPE elem) { return conv_idx2str_stat(conv_elem2idx_stat(elem)); };
	inline ETYPE	conv_idx2elem_xien(int index)  { return (ETYPE)index << ELEM_STARTBIT_XIEN; };
	inline ETYPE	conv_idx2elem_stat(int index)  { return (ETYPE)index << ELEM_STARTBIT_STAT; };
	inline ETYPE	conv_str2elem_xien(char *str)  { return conv_idx2elem_xien(conv_str2idx_xien(str)); };
	inline ETYPE	conv_str2elem_stat(char *str)  { return conv_idx2elem_stat(conv_str2idx_stat(str)); };
	inline char *	conv_idx2str_chara(int chara, bool use_oldname = false)
			{ return m_param->idx2str_chara(chara, use_oldname); };
	inline char *	conv_idx2str_style(int style)
			{ return m_param->style_name(style); };
	inline char *	conv_idx2str_cstyle(int style, bool use_oldname = false)
			{ return m_param->idx2str_style(style, use_oldname); };
	inline int		conv_str2idx(char *str)
			{ return m_param->str2idx(str); };
};

class GAimex_gasim : GAimex
{
public:
	void	imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
	void	imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
};

class GAimex_oresim : GAimex
{
public:
	void	imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
	void	imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
};

class GAimex_saibunpai : GAimex
{
public:
	void	imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
	void	imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
};

class GAimex_talessimu : GAimex
{
public:
	void	imex_vec2log(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
	void	imex_log2vec(int &vec_size, int *vec_lv1, int *vec_lv2, ETYPE *vec_elem, char *log);
};

#endif // __GAIMEX_H__
